*!	Pour faire fonctionner la classe dates vous devez dclarer une variable PUBLIC repfich et y 
*!	mettre le rpertoire dans lequel vous avez rang parametr.dbf et vacances.dbf

*!	Puis, dans la fentre de commande (les classes non visuelles sont trs faciles  
*!	dbugger  partir de cette fentre de commande), tapez

*!	public repfich
*!	repfich = ""          && contient le rpertoire o sont parametr et vacances
*!	set procedure to classes
*!	dada = createobject("dates")
*!	DEBUG
*!	vous allez voir, qu' part les proprits hrites de custom, dada est 'vide'.

*!	Imprimons  l'cran la premire date des vacances 
*!	 (alors que normalement elle n'est pas initialise ...) :
*!	? dada.vacances(1,1)

*!	et on obtient .... la bonne date ...  
*!	  parce que dans vacances_access j'ai fait en sorte d'initialiser le tableau 
*!	  qui ne l'tait pas encore. Retournez dans le dbuggeur, vous verrez que 
*!	  toutes les autres dates sont aussi initialises

*!	Vous pouvez dtruire l'objet par    dada = NULL
*!	suivi de    set procedure to

*!	Vous pouvez mettre un SET STEP ON 
*!	 au dbut de la mthode vacances_access pour voir ce qui se passe ....




DEFINE CLASS dates AS custom
  * liste des dates principales utilises dans l'application
  * de gestion d'une cole
  
  annee_scolaire = 0  && anne scolaire numrique
                      && cette proprit a 2 mthodes _assign et _access
                      && _assign va permettre de mettre  jour les proprits
                      && annexes et _access va permettre la mise  jour de
                      && annee_scolaire au moment de la premire utilisation
  lettre_annee = ""   && lettre code anne scolaire (dans la version DOS et donc dans
                      && les tables correspondant on utilise l'anne numrique
                      && et dans la partie purement VFP la code lettre de l'anne)
  texte_annee = ""    && ex '2004'
  texte_annee_scolaire = "" && ex '2004-2005'
  rentree = {}        && date de la rentre
  julrentree = 0      && date julienne correspondant  la rentre
                      && VFP utilise beaucoup les dates juliennes.
  sortie  = {}        && date de la sortie
  lundi_semaine1 = {} && premier lundi qui suit le 1er aot qui prcde la 
                      && date de rentre. Ce lundi est la base de tous
                      && les calculs de date pour l'anne scolaire en 
                      && particulier lorsqu'il s'agit de retrouver
                      && le bit corespondant dans une chane de 53 caractres.
  julsem1 = 0         && numro du jour julien correspondant  lundi_semaine1
                      && VFP utilise beaucoup les dates juliennes.
  nbre_trimestre = 0  && nombre de trimestre
  DIMENSION trimestres(1,2) && date dbut/fin de chaque trimestre
  * trimestres et nbre_trimestre ne sont pas encore grs ...
  nbre_facture = 0    && nombre de factures pour l'anne scolaire
  DIMENSION factures(1)     && dates des factures
  * factures et nbre_facture ne sont pas encore grs
  nbre_vacances = 0   && nombre de priodes de vacances
  DIMENSION vacances(1,3) && dates des vacances 1 dbut  2 fin  3 libell
  * Grce  la mthode _access sur nbre_vacances et sur vacances, on pourra initialiser
  * ces deux proprits au moment de leur premire lecture ! En fait si dans le droulement
  * de l'application, on n'en a pas besoin, elles ne seront pas mises  jour !

  PROCEDURE init
    * rien  faire pour l'instant
  ENDPROC && init
  
  * l'application est tire d'une appli DOS qui fonctionne encore mais
  * entretemps on a modifi la gestion des annes scolaires ...
  * les vnements _ASSIGN nous permettent de grer ce problme facilement
  * (avant on n'utilisait que des annes numriques, maintenant que des lettres code)
  HIDDEN PROCEDURE annee_scolaire_ASSIGN
    * chaque fois que l'on met une valeur dans annee_scolaire on passe ici
    * et donc on met  jour les proprits annexes
    * la procdure est HIDDEN parce que je ne veux pas qu'elle puisse tre surcharge
    * ou utilise par une sous-classe
    LPARAMETERS pnannee
    
    WITH This
	    .annee_scolaire = pnannee
	    IF pnannee > 1991 && scurit
		    .lettre_annee = CHR(65 + pnannee - 1992)
	      .texte_annee = STR( .annee_scolaire,4)
	      .texte_annee_scolaire = .texte_annee+"-"+STR( .annee_scolaire+1,4)
	      .lundi_semaine1 = CTOD("01/08/" + .texte_annee)
			  DO WHILE DOW( .lundi_semaine1,1) <> 2
			    .lundi_semaine1 = .lundi_semaine1 + 1
			  ENDDO
			  .julsem1 = VAL( SYS(11, .lundi_semaine1))
	    ELSE
		    STORE "" TO .lettre_annee, .texte_annee, .texte_annee_scolaire
	      .lundi_semaine1 = {}
			  .julsem1 = 0
	    ENDIF && pnannee > 1992
    ENDWITH  && This
  ENDPROC && annee_scolaire_ASSIGN
  
  HIDDEN PROCEDURE annee_scolaire_ACCESS
    * on veut lire l'anne scolaire, on vrifie qu'elle a bien t mise  jour
    * avec cette simple mthode on laisse la libert au dveloppeur de mettre
    *  jour annee_scolaire au dbut de l'application ou de ne rien faire
    * et dans ce cas la proprit est mise  jour  la premire utilisation
    IF This.annee_scolaire = 0
      * l'anne scolaire n'a pas t mise  jour, on le fait
      This.lecture_dates_principales()
      * j'ai vrifi : malgr que l'on relise this.annee_scolaire dans 
      * This.lecture_dates_principales, on ne relance pas cette mthode _access.
      * (VFP est intelligent !!)
    ENDIF && This.annee_scolaire = 0
    RETURN This.annee_scolaire
  ENDPROC && annee_scolaire_ACCESS
  
  HIDDEN PROCEDURE lettre_annee_ASSIGN
    LPARAMETERS pclettre
    * on fait le test pout viter une boucle infinie car en mettant  jour 
    * annee_scolaire, on remet  jour lettre_annee, etc ...
    
    IF ! This.lettre_annee == pclettre
	    This.lettre_annee = pclettre
	    This.annee_scolaire = 1992 - 65 + ASC(pclettre)
    ENDIF && This.lettre_annee = pclettre
  ENDPROC && lettre_annee_ASSIGN
  
  HIDDEN PROCEDURE nbre_vacances_access
    IF This.nbre_vacances = 0
      * a priori les vacances ne sont pas encore  jour, on le fait ici
      IF This.annee_scolaire > 0
        * il se peut que l'anne scolaire n'ait pas t mise  jour. Mais
        * on vient de la lire donc de la mettre  jour. Par contre, si elle
        * n'est pas dfinie dans parametr, elle est toujours = 0 et ce 
        * n'est pas la peine de chercher les vacances !
        This.lecture_vacances()
      ELSE
        This.nbre_vacances = 0
        DIMENSION This.vacances(1,3)
        STORE {} TO .vacances(1,1), .vacances(1,2)
        STORE "" TO .vacances(1,3)
      ENDIF && This.annee_scolaire > 0
    ENDIF && This.nbre_vacances = 0
    RETURN This.nbre_vacances
  ENDPROC && nbre_vacances_access
  
  HIDDEN PROCEDURE vacances_access && attention vacances est un tableau !
    * idem nbre_vacances_access
    LPARAMETERS lnligne, lncolonne  && VFP fournit la ligne et la colonne ...
    
    IF This.nbre_vacances = 0
      * a priori les vacances ne sont pas encore  jour, on le fait ici
      IF This.annee_scolaire > 0
        * il se peut que l'anne scolaire n'ait pas t mise  jour. Mais
        * on vient de la lire donc de la mettre  jour. Par contre, si elle
        * n'est pas dfinie dans parametr, elle est toujours = 0 et ce 
        * n'est pas la peine de chercher les vacances !
        This.lecture_vacances()
      ELSE
        This.nbre_vacances = 0
        DIMENSION This.vacances(1,3)
        STORE {} TO .vacances(1,1), .vacances(1,2)
        STORE "" TO .vacances(1,3)
      ENDIF && This.annee_scolaire > 0
    ENDIF && This.nbre_vacances = 0
    RETURN This.vacances( M.lnligne, M.lncolonne)
  ENDPROC && nbre_vacances_access
  
  
  
  PROCEDURE lecture_dates_principales
    *  jme 10/04/2005 en scurit, on continue  mettre  jour les variables PUBLIC
    WITH This
	    SELECT 0
		  USE (repfich+"parametr") ALIAS prmtoo NOUPDATE
		  LOCATE FOR prmtoo->code = "AS "  && anne scolaire
		  IF FOUND()
		    STORE prmtoo->num TO M.annscola, .annee_scolaire
			  * le fait de mettre  jour This.annee_scolaire va dclencher _assign 
			  * et donc la mise  jour des autres valeurs lies ... C'est magique !
			  * premier jour d'cole (rentre scolaire)
			  LOCATE FOR prmtoo->code = "DRT" AND prmtoo->num = .annee_scolaire
			  STORE IIF( FOUND(), prmtoo->date, lundi_semaine1) TO daterentr, .rentree
			  STORE VAL( SYS(11, daterentr)) TO .julrentree, julrentr
			  * dernier jour d'cole (grandes vacances)
			  LOCATE FOR prmtoo->code = "DSO" AND prmtoo->num = This.annee_scolaire
			  STORE IIF( FOUND(), prmtoo->date, daterentr +320) TO datsortie, This.sortie
		  ENDIF
		  USE
    ENDWITH  && This
  ENDPROC &&  lecture_dates_principales

  PROCEDURE lecture_vacances && jme 10/04/2005
    LOCAL lnseldep, llouvvacan, lnaccu
    
    WITH This
	    lnseldep = SELECT(0)
	    IF !USED("vacan")
	      USE (repfich+"vacances") ALIAS vacan IN 0 NOUPDATE
	      llouvvacan = .T.
	    ELSE
	      llouvvacan = .F.
	    ENDIF && !USED("vacan")
	    SELECT datdebut, datfin, libelle FROM vacan ;
	     WHERE ascol = .annee_scolaire ORDER BY datdebut INTO CURSOR tmpvac
      .nbre_vacances = RECCOUNT()   && nombre de priodes de vacances
      IF .nbre_vacances > 0
        DIMENSION This.vacances( .nbre_vacances, 3)
        lnaccu = 1
        SCAN ALL
          .vacances( M.lnaccu, 1) = tmpvac.datdebut
          .vacances( M.lnaccu, 2) = tmpvac.datfin
          .vacances( M.lnaccu, 3) = tmpvac.libelle
          lnaccu = M.lnaccu + 1
        ENDSCAN
      ELSE
        DIMENSION This.vacances( 1, 3)
        STORE {} TO .vacances(1,1), .vacances(1,2)
        STORE "" TO .vacances(1,3)
      ENDIF && .nbre_vacances > 0
      USE IN tmpvac
      IF llouvvacan = .T.
        USE IN vacan
      ENDIF && llouvvacan = .T.
      SELECT (M.lnseldep)
    ENDWITH  && This
  ENDPROC && lecture_vacances
ENDDEFINE && CLASS dates AS custom
